﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.81
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private server As ServerSocket
	Private astream As AsyncStreams
	Public IsConnected As Boolean
	Private tmr As Timer
	Private ser As B4XSerializator
	Public ScreenColor As Int
End Sub

Sub Service_Create
	ListenForConnections
	tmr.Initialize("tmr", 1000)
	ScreenColor = Colors.White
End Sub

Private Sub ListenForConnections
	server.Initialize(51042, "server")
	Log($"My ip is: ${server.GetMyWifiIP}"$)
	Do While True
		server.Listen
		Wait For server_NewConnection (Successful As Boolean, NewSocket As Socket)
		Log("New connection")
		If Successful Then
			If astream.IsInitialized Then
				astream.Close
			End If
			astream.InitializePrefix(NewSocket.InputStream, True, NewSocket.OutputStream, "astream")
			SetState(True)
		End If
	Loop
End Sub

Private Sub SetState (connected As Boolean)
	IsConnected = connected
	tmr.Enabled = connected
	CallSub(Main, "StateChanged")
End Sub

Private Sub tmr_Tick
	Dim s As String = $"My time is $Time{DateTime.Now}"$
	Dim mm As MyMessage
	mm.Initialize
	mm.Message = s
	astream.Write(ser.ConvertObjectToBytes(mm))
End Sub

Private Sub Astream_NewData (Buffer() As Byte)
	Dim mm As MyMessage = ser.ConvertBytesToObject(Buffer)
	ScreenColor = mm.ScreenColor
	CallSub(Main, "StateChanged")
End Sub

Private Sub Astream_Terminated
	SetState(False)
End Sub

Private Sub Astream_Error
	Astream_Terminated
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
